#include "TimSynth.h"

void volcopy_rombuf8dup_to_buf16(const rom signed char rom *buf, signed short *buf2, unsigned char volume)
{
	_asm
		//	set TBLPTR to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, TBLPTRL
		MOVLW 0xfe
		MOVFF PLUSW2, TBLPTRH
		
		//	set FSR0 to *buf2
		MOVLW 0xfb
  		MOVFF PLUSW2, FSR0L
		MOVLW 0xfc
		MOVFF PLUSW2, FSR0H
		
		//	bufcnt = BUFSIZE;
		MOVLW BUFSIZE/2
		MOVWF bufcnt, ACCESS
		
		//	set cval to volume
		MOVLW 0xfa
		MOVF PLUSW2, W, ACCESS
		MOVWF cval, ACCESS

AGAIN:	

		TBLRDPOSTINC				// put sample from rom in TABLAT
		
		// first adjust the volume of the rom sample
		MOVF	TABLAT, W, ACCESS
		MOVWF	tempshort, ACCESS
		CLRF	tempshort+1, ACCESS
		BTFSC	tempshort, 7, ACCESS
		SETF	tempshort+1, ACCESS
		
		MOVF	cval, W, ACCESS
		MULWF	tempshort+1, ACCESS
		MOVFF	PRODL, tempshort+1
		MULWF	tempshort, ACCESS
		MOVFF	PRODL, tempshort
		MOVF	PRODH, W, ACCESS
		ADDWF	tempshort+1, F, ACCESS
		
		MOVLW	0x00
		BTFSC	TABLAT, 7, ACCESS
		MOVLW	0xFF

		MOVFF	tempshort+1, POSTINC0
		MOVWF	POSTINC0, ACCESS
		MOVFF	tempshort+1, POSTINC0
		MOVWF	POSTINC0, ACCESS
		
		DECFSZ bufcnt, F, ACCESS
		BRA AGAIN

	_endasm
}
