#include "TimSynth.h"

// DAC buffers
#pragma udata dac_buf_1 = 0x600
signed char dac_buf_1[BUFSIZE];
#pragma udata dac_buf_2 = 0x640
signed char dac_buf_2[BUFSIZE];

// ADC buffers
#pragma udata adc_buf_1 = 0x680
signed char adc_buf_1[BUFSIZE];
#pragma udata adc_buf_2 = 0x6C0
signed char adc_buf_2[BUFSIZE];

// buffer for generated noise
#pragma udata noisebuf = 0x700
signed char noisebuffer[BUFSIZE];

// downmix buffer
#pragma udata downbuf = 0x800
signed short downbuf[BUFSIZE];

// 8-bit scratchpad buffers
#pragma udata scratchbuf8_1 = 0x740
signed char scratchbuf8_1[BUFSIZE];
#pragma udata scratchbuf8_2 = 0x780
signed char scratchbuf8_2[BUFSIZE];
#pragma udata scratchbuf8_3 = 0x7C0
signed char scratchbuf8_3[BUFSIZE];

// 16-scratchpad buffers
#pragma udata scratchbuf16_1 = 0x880
signed short scratchbuf16_1[BUFSIZE];
#pragma udata scratchbuf16_2 = 0x900
signed short scratchbuf16_2[BUFSIZE];
#pragma udata scratchbuf16_3 = 0x980
signed short scratchbuf16_3[BUFSIZE];



#pragma udata access core_buffer_flags

near union _buffer_flags core_buffer_flags;

#pragma udata

void audio_buffers_init(void)
{
	clear_buf8(dac_buf_1);
	clear_buf8(dac_buf_2);

	clear_buf8(adc_buf_1);
	clear_buf8(adc_buf_2);

	clear_buf8(noisebuffer);

	clear_buf16(downbuf);

	clear_buf8(scratchbuf8_1);
	clear_buf8(scratchbuf8_2);
	clear_buf8(scratchbuf8_2);

	clear_buf16(scratchbuf16_1);
	clear_buf16(scratchbuf16_2);
	clear_buf16(scratchbuf16_2);
	
	core_buffer_flags.raw = 0x00;
}
