#ifndef AUDIO_BUFFERS_H
#define AUDIO_BUFFERS_H

#include "sysconfig.h"

#define SBUF_BASE		0x06
#define NOISEBUF_BASE	0x07
#define DOWNBUF_BASE	0x08

#define BUFFER_1_FLAG	0x01
#define BUFFER_2_FLAG	0x02

#define DO_COREBUF		core_buffer_flags.raw
#define DO_COREBUF_1	core_buffer_flags.process_buffer_1
#define DO_COREBUF_2	core_buffer_flags.process_buffer_2

typedef union _buffer_flags
{
	unsigned char raw;
	
	struct
	{
		unsigned char process_buffer_1:1;
		unsigned char process_buffer_2:1;
		unsigned char _unused:6;
	};
};


extern signed char dac_buf_1[BUFSIZE];
extern signed char dac_buf_2[BUFSIZE];
extern signed char adc_buf_1[BUFSIZE];
extern signed char adc_buf_2[BUFSIZE];

extern signed char noisebuffer[BUFSIZE];

extern signed short downbuf[BUFSIZE];

extern signed char scratchbuf8_1[BUFSIZE];
extern signed char scratchbuf8_2[BUFSIZE];
extern signed char scratchbuf8_3[BUFSIZE];

extern signed short scratchbuf16_1[BUFSIZE];
extern signed short scratchbuf16_2[BUFSIZE];
extern signed short scratchbuf16_3[BUFSIZE];


extern near union _buffer_flags core_buffer_flags;

void audio_buffers_init(void);

#endif
