#ifndef AUDIO_KERNELS_H
#define AUDIO_KERNELS_H

extern near unsigned char cval;
extern near unsigned char bufcnt;
extern near unsigned char tempchar;
extern near unsigned short tempshort;

extern signed short *ssbuf, *ssbuf2;
extern unsigned char fsr2h_save, fsr2l_save;

// for c-implementation of kernels
extern signed char *scbuf;

void clear_buf16(signed short *buf);
void clear_buf8(signed char *buf);

void buf8_volume(signed char *buf, unsigned char vol);
void buf8_volume_by_buf8(signed char *buf, signed char *buf2);
void buf16_volume(signed short *buf, unsigned char vol);
void buf16_volume_by_buf8(signed short *buf, signed char *buf2);

void copy_buf8_to_buf8(signed char *buf, signed char *buf2);
void copy_buf8_to_buf16(signed char *buf, signed short *buf2);
void copy_buf16_to_buf8(signed short *buf, signed char *buf2);
void copy_buf16_to_buf16(signed short *buf, signed short *buf2);

void copy_chunk8(signed char *buf, signed char *buf2, unsigned char count);
void copy_chunk16(signed short *buf, signed short *buf2, unsigned char count);

void copy_rombuf8_to_buf8(const rom signed char rom *buf, signed char *buf2);
void copy_rombuf8dup_to_buf8(const rom signed char rom *buf, signed char *buf2);
void copy_rombuf8_to_buf16(const rom signed char rom *buf, signed short *buf2);
void copy_rombuf8dup_to_buf16(const rom signed char rom *buf, signed short *buf2);

void add_buf8_to_buf8(signed char *buf, signed char *buf2);
void add_buf8_to_buf16(signed char *buf, signed short *buf2);
void add_buf16_to_buf8(signed short *buf, signed char *buf2);
void add_buf16_to_buf16(signed short *buf, signed short *buf2);

void mix_rombuf8_to_buf16(const rom signed char rom *buf, signed short *buf2, unsigned char volume);
void mix_rombuf8dup_to_buf16(const rom signed char rom *buf, signed short *buf2, unsigned char volume);

void volcopy_rombuf8_to_buf16(const rom signed char rom *buf, signed short *buf2, unsigned char volume);
void volcopy_rombuf8dup_to_buf16(const rom signed char rom *buf, signed short *buf2, unsigned char volume);

void and_buf8(signed char *buf, unsigned char par);
void or_buf8(signed char *buf, unsigned char par);
void xor_buf8(signed char *buf, unsigned char par);
void neg_buf8(signed char *buf, unsigned char par);

void and_buf8_by_buf8(signed char *buf, signed char *buf2);
void or_buf8_by_buf8(signed char *buf, signed char *buf2);
void xor_buf8_by_buf8(signed char *buf, signed char *buf2);

void and_buf16(signed short *buf, unsigned short par);
void or_buf16(signed short *buf, unsigned short par);
void xor_buf16(signed short *buf, unsigned short par);
void neg_buf16(signed short *buf, unsigned short par);

void and_buf16_by_buf16(signed short *buf, signed short *buf2);
void or_buf16_by_buf16(signed short *buf, signed short *buf2);
void xor_buf16_by_buf16(signed short *buf, signed short *buf2);

#endif