#ifndef MODULE_H
#define MODULE_H

#include "mytypes.h"


typedef struct _module_info
{
	func	init_func;
	func	run_func;
	func	exit_func;
};

#define MODULE_DEF(X) \
	void X ## _init(void); \
	void X ## _run(void); \
	void X ## _exit(void); \
	extern const rom struct _module_info rom X;

#define MODULE_IMPL(X) \
	const rom struct _module_info rom X =\
	{\
		(func)X ## _init,\
		(func)X ## _run,\
		(func)X ## _exit\
	};
	
#define EXIT_MODULE(X) \
	module_handler_exit_module(X);\
	return;

#define HANDLE_EXIT(X) \
	if(CLICKED_8) \
	{ \
		if(BUTTON_M) \
		{ \
			module_handler_exit_module(X);\
			return; \
		} \
	}



#endif
