#include "TimSynth.h"

#pragma udata access run_module
near func cur_module_func;

#pragma udata

struct _module_info rom *current_module;

static unsigned char old_led_config[32];
static unsigned char level;
static rom struct _module_info rom *prev_module[32];

void empty_func(void)
{
	_asm NOP _endasm;
}

void module_handler_init(void)
{
	for(level = 0; level < 32; level++)
	{
		prev_module[level] = 0;
		old_led_config[level] = 0;
	}
	
	level = 0;
	
	current_module = (struct _module_info rom *) &mod_mainmenu;
	
	cur_module_func = current_module->run_func;
	
	(current_module->init_func)();
}

void module_handler_start_module(const rom struct _module_info *module, unsigned char do_init)
{
	if(module)
	{
		if(level < 32)
		{
			old_led_config[level] = led_config;
			prev_module[level] = current_module;
			
			level++;
			
			current_module = (rom struct _module_info rom *) module;
	
			cur_module_func = module->run_func;
	
			if(do_init)
			{
				(current_module->init_func)();
			}
			
			CLICKED = 0;
		}
	}
}

void module_handler_exit_module(unsigned char do_exit)
{
	if(level)
	{
		level--;
		led_reset();
		led_config = old_led_config[level];

		if(do_exit)
		{
			(current_module->exit_func)();
		}

		current_module = (rom struct _module_info rom *) prev_module[level];

		cur_module_func = current_module->run_func;

		CLICKED = 0;
	}
}
