#include "TimSynth.h"

void hardware_init(void)
{
	// configure oscillator, internal 16MHz, x4 PLL
	OSCCON = 0b11111100;
	OSCTUNE = 0b01000000;

	// configure and preset i/o pins
	//         ---EDCBA
	SLRCON = 0b00011111;
	
	TRISA = 0xFF;
	LATA = 0x00;
	
	TRISB = 0b11100111;
	LATB = 0x00;
	

	CCP1CON = 0x00;
	TRISC = 0x00000101;
	TRISCbits.TRISC2 = 1;
	LATC = 0x00;
	
	// configure SPI module for LED's
	SSPSTATbits.SMP = 0;
	SSPSTATbits.CKE = 1;
	SSPSTATbits.BF = 0;
	
	SSPCON1 = 0x01;
	SSPCON1bits.CKP = 0;
	
	// configure analogue section
	ANSEL = 0b00000011;
	ANSELH = 0b00000000;
	
	ADCON2 = 0b00010110;

	ADCON1 = 0b00000000;
	ADCON0 = 0b00000001;
	
	// configure voltage reference module
	CVRCON = 0b11001000;
	CVRCON2 = 0b00000000;

	// configure PWM module and the needed TMR2
	CCP2CON = 0b00001111;
	PR2 = 0x3F;
	CCPR2L = 0x00;
	TMR2 = 0x00;
	T2CON = 0b01011000;
	
	// configure SPI module for led's
	PIR1bits.SSPIF = 0;
	SSPCON1bits.SSPEN = 1;
}


