#ifndef SEQTIMING_H
#define SEQTIMING_H

#include "hardware.h"
#include "mytypes.h"

#define MICROSTEPS	4
#define PRESCALE	16
#define TIMERFREQ	(float)(CLOCKFREQ/PRESCALE)

#define TIMERTICKS_PER_SEC	(TIMERFREQ)
#define TIMERTICKS_PER_MSEC (TIMERFREQ/1000.0)
#define TIMERTICKS_PER_uSEC	(TIMERFREQ/1000000.0)

#define SEC_PER_TIMERTICK	(1.0/TIMERFREQ)
#define MSEC_PER_TIMERTICK	(1.0/(TIMERFREQ/1000.0))
#define USEC_PER_TIMERTICK	(1.0/(TIMERFREQ/1000000.0))

#define	BPM_MIN	127
#define BPM_MAX	30000

#define STEP_MAX	16
#define BAR_MAX		16

extern near unsigned char microstep;
extern near unsigned char step_pos;
extern near unsigned char num_steps;
extern near unsigned char current_step;

extern near unsigned char bar_pos;
extern near unsigned char num_bars;
extern near unsigned char current_bar;

extern near unsigned char new_step;
extern near union _u16_u8x2 seq_t;
extern near unsigned short t0_reload;

extern near unsigned long short seqtiming_speed;

void seqtiming_init(unsigned short bpm);

void seqtiming_start(void);
void seqtiming_continue(void);
void seqtiming_restart(unsigned short bpm);
void seqtiming_pause(void);
void seqtiming_stop(void);

void seqtiming_calculate_tspeed(unsigned short bpm);
void seqtiming_load_tspeed(unsigned short tspeed);
void seqtiming_set_bpm(unsigned short bpm);
void seqtiming_faster(unsigned short bpm_increase);
void seqtiming_slower(unsigned short bpm_decrease);

void seqtiming_reset_steps(void);
void seqtiming_reset_bars(void);
void seqtiming_set_num_steps(unsigned char nsteps);
void seqtiming_set_num_bars(unsigned char nbars);



#endif
