#ifndef LED_H
#define LED_H

typedef union _ledbits
{
	unsigned char raw;
	
	struct
	{
		unsigned char bled1:1;
		unsigned char bled2:1;
		unsigned char bled3:1;
		unsigned char bled4:1;
		unsigned char bled5:1;
		unsigned char bled6:1;
		unsigned char bled7:1;
		unsigned char bled8:1;
	};
};

#define BUTTON_LEDS	leds.bleds
#define BUTTON_LED1	leds.bled1
#define BUTTON_LED2	leds.bled2
#define BUTTON_LED3	leds.bled3
#define BUTTON_LED4	leds.bled4
#define BUTTON_LED5	leds.bled5
#define BUTTON_LED6	leds.bled6
#define BUTTON_LED7	leds.bled7
#define BUTTON_LED8	leds.bled8

#define EXTRA_LED1	LATBbits.LATB4
#define EXTRA_LED2	LATBbits.LATB3

/*
#define SHOW_DIM			0x01
#define SHOW_MED			0x02
#define SHOW_STEP_ELED1		0x04
#define SHOW_STEP_ELED2		0x08
#define SHOW_BAR_ELED1		0x10
#define SHOW_BAR_ELED2		0x20
#define SHOW_SEQ_ELED1		0x40
#define SHOW_SEQ_ELED2		0x80
*/

#define SHOW_BUTTON_LED		0x01
#define SHOW_DIM_LED		0x02
#define SHOW_MED_LED		0x04
#define SHOW_BRIGHT_LED		0x08

#define SHOW_STEP_DIM		0x10
#define SHOW_STEP_MED		0x20

#define SHOW_BAR_DIM		0x40
#define SHOW_BAR_MED		0x80

#define ASM_SHOW_BUTTON_LED		led_config, 0, ACCESS
#define ASM_SHOW_DIM_LED		led_config, 1, ACCESS
#define ASM_SHOW_MED_LED		led_config, 2, ACCESS
#define ASM_SHOW_BRIGHT_LED		led_config, 3, ACCESS

#define ASM_SHOW_STEP_DIM		led_config, 4, ACCESS
#define ASM_SHOW_STEP_MED		led_config, 5, ACCESS

#define ASM_SHOW_BAR_DIM		led_config, 6, ACCESS
#define ASM_SHOW_BAR_MED		led_config, 7, ACCESS

// led working registers
extern near union _ledbits leds;

// main led flags for different brightness levels
extern near unsigned char dim_led;
extern near unsigned char med_led;
extern near unsigned char bright_led;

extern near unsigned char led_config;
//extern near unsigned char display_status;

// internal bit walker
extern near unsigned char led_cnt;

// main led routines
void led_init(void);
void led_reset(void);

#endif
