#include "TimSynth.h"

extern const rom struct _module_info *rom mainmenu_entries[];

static unsigned char entries_normal, entries_m;

const rom struct _module_info rom mod_mainmenu =
{
	(const rom void*)&mod_mainmenu_init,
	(const rom void*)&mod_mainmenu_run
};

void mod_mainmenu_init(void)
{
	unsigned char cnt;
	unsigned char pos;
	
	unsigned short rom *content;
	unsigned short cc;
	
	content = (unsigned short rom*)mainmenu_entries;
	
	entries_normal = 0;
	entries_m = 0;
	
	pos = 0x01;

	for(cnt = 0; cnt < 8; cnt++)
	{
		if(content[cnt])
		{
			entries_normal |= pos;
		}
		
		pos <<= 1;
	}
	
	pos = 0x01;

	for(cnt = 8; cnt < 16; cnt++)
	{
		if(content[cnt])
		{
			entries_m |= pos;
		}
		
		pos <<= 1;
	}
	
	led_reset();
	led_config = SHOW_BUTTON_LED | SHOW_DIM_LED | SHOW_MED_LED | SHOW_BRIGHT_LED;
	dim_led = 0;
	med_led = 0;
	bright_led = 0;
}

void mod_mainmenu_run(void)
{
	if(BUTTON_M)
	{
		dim_led = entries_m;
	}
	else
	{
		dim_led = entries_normal;
	}

	if(CLICKED)
	{
		if(BUTTON_M)
		{
			dim_led = entries_m;

			if(CLICKED_1 && (entries_normal & 0x01))
			{
				module_handler_start_module(mainmenu_entries[8], WITH_INIT);
			}
			if(CLICKED_2 && (entries_normal & 0x02))
			{
				module_handler_start_module(mainmenu_entries[9], WITH_INIT);
			}
			if(CLICKED_3 && (entries_normal & 0x04))
			{
				module_handler_start_module(mainmenu_entries[10], WITH_INIT);
			}
			if(CLICKED_4 && (entries_normal & 0x08))
			{
				module_handler_start_module(mainmenu_entries[11], WITH_INIT);
			}
			if(CLICKED_5 && (entries_normal & 0x10))
			{
				module_handler_start_module(mainmenu_entries[12], WITH_INIT);
			}
			if(CLICKED_6 && (entries_normal & 0x20))
			{
				module_handler_start_module(mainmenu_entries[13], WITH_INIT);
			}
			if(CLICKED_7 && (entries_normal & 0x40))
			{
				module_handler_start_module(mainmenu_entries[14], WITH_INIT);
			}
			if(CLICKED_8 && (entries_normal & 0x80))
			{
				module_handler_start_module(mainmenu_entries[15], WITH_INIT);
			}		
		}
		else
		{
			dim_led = entries_normal;
			
			if(CLICKED_1 && (entries_normal & 0x01))
			{
				module_handler_start_module(mainmenu_entries[0], WITH_INIT);
			}
			if(CLICKED_2 && (entries_normal & 0x02))
			{
				module_handler_start_module(mainmenu_entries[1], WITH_INIT);
			}
			if(CLICKED_3 && (entries_normal & 0x04))
			{
				module_handler_start_module(mainmenu_entries[2], WITH_INIT);
			}
			if(CLICKED_4 && (entries_normal & 0x08))
			{
				module_handler_start_module(mainmenu_entries[3], WITH_INIT);
			}
			if(CLICKED_5 && (entries_normal & 0x10))
			{
				module_handler_start_module(mainmenu_entries[4], WITH_INIT);
			}
			if(CLICKED_6 && (entries_normal & 0x20))
			{
				module_handler_start_module(mainmenu_entries[5], WITH_INIT);
			}
			if(CLICKED_7 && (entries_normal & 0x40))
			{
				module_handler_start_module(mainmenu_entries[6], WITH_INIT);
			}
			if(CLICKED_8 && (entries_normal & 0x80))
			{
				module_handler_start_module(mainmenu_entries[7], WITH_INIT);
			}		
		}
	}
}

void mod_mainmenu_exit(void)
{
}
